"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.UserDocument = void 0;
const DraftState_1 = require("./state/DraftState");
class UserDocument {
    constructor(user) {
        this._currentUser = user;
        this.changeState(new DraftState_1.DraftState());
    }
    changeState(state) {
        this._state = state;
        this._state.setDocument(this);
    }
    get currentUser() {
        return this._currentUser;
    }
    sendForDraft() {
        this._state.draft();
    }
    sendForModeration() {
        this._state.moderate();
    }
    sendForPublication() {
        this._state.publish();
    }
}
exports.UserDocument = UserDocument;
