import { DraftState } from "./state/DraftState";
import { State } from "./state/State";

export class UserDocument {
  private _state!: State;
  private _currentUser: string;

  constructor(user: string) {
    this._currentUser = user;
    this.changeState(new DraftState());
  }

  public changeState(state: State) {
    this._state = state;
    this._state.setDocument(this);
  }

  get currentUser(): string {
    return this._currentUser;
  }

  public sendForDraft(): void {
    this._state.draft();
  }

  public sendForModeration(): void {
    this._state.moderate();
  }

  public sendForPublication(): void {
    this._state.publish();
  }

  // public publish() {
  //   switch(this._state) {
  //     case 'draft':
  //       this._state = 'moderation';
  //       break;
  //     case 'moderation':
  //       if (this._currentUser === 'admin') {
  //         this._state = 'published';
  //       } else {
  //         console.log('У вас нет прав');
  //       }
  //       break;
  //     case 'published':
  //       break;
  //   }
  // }

  
}