import { DraftState } from "./DraftState";
import { PublishedState } from "./PublishedState";
import { State } from "./State";

export class ModeratedState extends State {
  public override draft(): void {
    console.log('Документ отправлен на повторную подготовку');
    this.document.changeState(new DraftState());
  }
  public override moderate(): void {
    console.log('Документ уже находится в модерации');
  }
  public override publish(): void {
    if (this.document.currentUser === "admin") {
      console.log('Отправляем документ на публикацию');
      this.document.changeState(new PublishedState());
    } else {
      console.log('У вас нет прав на публикацию');
    }
  }
}